﻿Type=Activity
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: False
#End Region

Sub Process_Globals
	Private ion As Object
End Sub

Sub Globals
	Private Button1 As Button
	Private NativeMe As JavaObject
	Private fp,imagefile As String
	Private ImageView1 As ImageView
	Private Button2 As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("2")
	
	If FirstTime Then
     NativeMe.InitializeContext
    End If
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub


Sub Button1_Click
	Dim DIRECTORY_PICTURES As String = NativeMe.RunMethod("DIRECTORY_PICTURES", Null) 'GET PICTURE DIRECTORY LIKE SHOW ON GOOGLE API DOCUMENTATION
	
    Dim getExternalFilesDir As String = NativeMe.RunMethod("getExternalFilesDir", Array(Null)) 'GET EXTERNAL FILES DIRECTORY LIKE SHOW ON GOOGLE API DOCUMENTATION

	File.MakeDir(getExternalFilesDir,DIRECTORY_PICTURES) 'MAKE A THIS PICTURES IF NOT EXIST
	
	fp = File.Combine(getExternalFilesDir,DIRECTORY_PICTURES) 'COMBINE THE DIR WITH DEFAULT PICTURE FOLDER NAME
	
	'RESULTS 
	Log("Folder: "& fp)
	Log("FileName: "& GetFileName)
	imagefile = GetFileName

    Dim i As Intent
    i.Initialize("android.media.action.IMAGE_CAPTURE", "")
	i.PutExtra("output", ParseUri("file://" & File.Combine(fp,GetFileName))) 'OPEN THE INTENT WITH THE CORRECT FOLDER AND CORRECT FILE NAME
  	StartActivityForResult(i)
	
End Sub

Sub Button2_Click
	Activity.Finish
End Sub



'GET FULL SIZE IMAGE
Sub ion_Event (MethodName As String, Args( ) As Object) As Object
  If Args(0) = -1 Then '= RESULT_OK
  	Dim i As Intent = Args(1)
	Log(i.ExtrasToString)

	If File.Exists(fp,imagefile) Then 
		Log("Image Saved") 'HERE IS THE IMAGE
		ImageView1.Bitmap = LoadBitmapSample(fp,imagefile,ImageView1.Width,ImageView1.Height)
	End If

   End If
Return Null
End Sub



Sub StartActivityForResult(i As Intent)
   Dim jo As JavaObject = GetBA
   ion = jo.CreateEvent("anywheresoftware.b4a.IOnActivityResult", "ion", Null)
   jo.RunMethod("startActivityForResult", Array As Object(ion, i))
End Sub

Sub GetBA As JavaObject
   Dim jo As JavaObject
   Dim cls As String = Me
   cls = cls.SubString("class ".Length)
   jo.InitializeStatic(cls)
   Return jo.GetField("processBA")
End Sub



'GET FILE NAME, LIKE ANDROID API DOCUMENTATION
Sub GetFileName As String
	DateTime.TimeFormat = "yyyyMMdd_HHmmss"
	Private timestamps As String = DateTime.Time(DateTime.Now)
	Private imageFileName As String = "JPEG_" & timestamps & "_.jpg"
	Return imageFileName
End Sub



'GET DEFAULT PICTURES DIR
#If JAVA
public String DIRECTORY_PICTURES() {
   return android.os.Environment.DIRECTORY_PICTURES;
}
#End If


Sub ParseUri(FileName As String) As Object
    Dim r As Reflector
    Return r.RunStaticMethod("android.net.Uri", "parse", Array As Object(FileName), Array As String("java.lang.String"))
End Sub


